<?php
# revision : $Rev: 59 $
# auteur   : $Author: marc-travail $
# Date     : $Date: 2012-07-24 08:53:36 +0200 (mar., 24 juil. 2012) $
# URL      : $HeadURL: svn+ssh://subversion@svn.vous-et-nous.com/home/subversion/repository/formations/utils_presentation/class/html_entities.class.php $

abstract class html_entities {
  
  static private $entities = array('¶' => '&para;',
				   '∈' => '&isin;',
				   '♠' => '&spades;',
				   'Š' => '&Scaron;',
				   'ó' => '&oacute;',
				   'Ú' => '&Uacute;',
				   '‍' => '&zwj;',
				   'Φ' => '&Phi;',
				   '£' => '&pound;',
				   'š' => '&scaron;',
				   'Ο' => '&Omicron;',
				   'φ' => '&phi;',
				   '€' => '&euro;',
				   'α' => '&alpha;',
				   '‾' => '&oline;',
				   'ì' => '&igrave;',
				   'þ' => '&thorn;',
				   ' ' => '&ensp;',
				   '∏' => '&prod;',
				   '≤' => '&le;',
				   '→' => '&rarr;',
				   '¦' => '&brvbar;',
				   ' ' => '&nbsp;',
				   '∑' => '&sum;',
				   'Ä' => '&Auml;',
				   '¸' => '&cedil;',
				   '±' => '&plusmn;',
				   '¨' => '&uml;',
				   '»' => '&raquo;',
				   '«' => '&laquo;',
				   '℘' => '&weierp;',
				   'σ' => '&sigma;',
				   '÷' => '&divide;',
				   'β' => '&beta;',
				   '∫' => '&int;',
				   '″' => '&Prime;',
				   '⊇' => '&supe;',
				   'Ν' => '&Nu;',
				   'í' => '&iacute;',
				   '∠' => '&ang;',
				   'Β' => '&Beta;',
				   '‘' => '&lsquo;',
				   '†' => '&dagger;',
				   'Ø' => '&Oslash;',
				   '´' => '&acute;',
				   '¾' => '&frac34;',
				   'ℑ' => '&image;',
				   'Κ' => '&Kappa;',
				   '∅' => '&empty;',
				   '≅' => '&cong;',
				   '∂' => '&part;',
				   'ρ' => '&rho;',
				   '∴' => '&there4;',
				   'á' => '&aacute;',
				   '˜' => '&tilde;',
				   'Ý' => '&Yacute;',
				   '„' => '&bdquo;',
				   '≡' => '&equiv;',
				   '≠' => '&ne;',
				   '↓' => '&darr;',
				   'ξ' => '&xi;',
				   'Γ' => '&Gamma;',
				   'Ö' => '&Ouml;',
				   'ò' => '&ograve;',
				   '©' => '&copy;',
				   'Ψ' => '&Psi;',
				   'â' => '&acirc;',
				   'Ó' => '&Oacute;',
				   'Í' => '&Iacute;',
				   '⌋' => '&rfloor;',
				   '∪' => '&cup;',
				   'ω' => '&omega;',
				   '∇' => '&nabla;',
				   'è' => '&egrave;',
				   'é' => '&eacute;',
				   '⇐' => '&lArr;',
				   '∗' => '&lowast;',
				   'Ç' => '&Ccedil;',
				   'Δ' => '&Delta;',
				   '♦' => '&diams;',
				   '•' => '&bull;',
				   '⌉' => '&rceil;',
				   'ƒ' => '&fnof;',
				   'Λ' => '&Lambda;',
				   'υ' => '&upsilon;',
				   '⌊' => '&lfloor;',
				   '¢' => '&cent;',
				   ' ' => '&emsp;',
				   '∧' => '&and;',
				   'Á' => '&Aacute;',
				   '§' => '&sect;',
				   'Ù' => '&Ugrave;',
				   'æ' => '&aelig;',
				   '∉' => '&notin;',
				   '〈' => '&lang;',
				   '¤' => '&curren;',
				   'ª' => '&ordf;',
				   '⊗' => '&otimes;',
				   '◊' => '&loz;',
				   '¯' => '&macr;',
				   'ϖ' => '&piv;',
				   'ˆ' => '&circ;',
				   '²' => '&sup2;',
				   '∞' => '&infin;',
				   'å' => '&aring;',
				   'π' => '&pi;',
				   'τ' => '&tau;',
				   '←' => '&larr;',
				   'Χ' => '&Chi;',
				   '“' => '&ldquo;',
				   '‚' => '&sbquo;',
				   'ς' => '&sigmaf;',
				   '⇓' => '&dArr;',
				   '‡' => '&Dagger;',
				   'õ' => '&otilde;',
				   'ü' => '&uuml;',
				   'ú' => '&uacute;',
				   'ν' => '&nu;',
				   '∩' => '&cap;',
				   'Τ' => '&Tau;',
				   'à' => '&agrave;',
				   'κ' => '&kappa;',
				   'Ô' => '&Ocirc;',
				   '⇔' => '&hArr;',
				   'ß' => '&szlig;',
				   'µ' => '&micro;',
				   '⁄' => '&frasl;',
				   '”' => '&rdquo;',
				   '‹' => '&lsaquo;',
				   '¬' => '&not;',
				   'ο' => '&omicron;',
				   '≈' => '&asymp;',
				   'χ' => '&chi;',
				   'ϑ' => '&thetasym;',
				   'Π' => '&Pi;',
				   '¹' => '&sup1;',
				   'ε' => '&epsilon;',
				   'ψ' => '&psi;',
				   '·' => '&middot;',
				   '∃' => '&exist;',
				   'ê' => '&ecirc;',
				   'θ' => '&theta;',
				   'ℜ' => '&real;',
				   '↔' => '&harr;',
				   'ñ' => '&ntilde;',
				   '≥' => '&ge;',
				   'ã' => '&atilde;',
				   '〉' => '&rang;',
				   'Ë' => '&Euml;',
				   'Ρ' => '&Rho;',
				   'ℵ' => '&alefsym;',
				   'Ñ' => '&Ntilde;',
				   '↵' => '&crarr;',
				   '⇒' => '&rArr;',
				   'Þ' => '&THORN;',
				   'É' => '&Eacute;',
				   '⊥' => '&perp;',
				   'Ü' => '&Uuml;',
				   'Å' => '&Aring;',
				   '–' => '&ndash;',
				   'ù' => '&ugrave;',
				   'È' => '&Egrave;',
				   'Â' => '&Acirc;',
				   'Σ' => '&Sigma;',
				   'ø' => '&oslash;',
				   'Ð' => '&ETH;',
				   'Ò' => '&Ograve;',
				   '…' => '&hellip;',
				   '⋅' => '&sdot;',
				   '∋' => '&ni;',
				   '′' => '&prime;',
				   '›' => '&rsaquo;',
				   'γ' => '&gamma;',
				   'î' => '&icirc;',
				   'ð' => '&eth;',
				   '−' => '&minus;',
				   'º' => '&ordm;',
				   '®' => '&reg;',
				   'û' => '&ucirc;',
				   'À' => '&Agrave;',
				   'Ω' => '&Omega;',
				   '⊆' => '&sube;',
				   '×' => '&times;',
				   '°' => '&deg;',
				   'Æ' => '&AElig;',
				   'δ' => '&delta;',
				   'Õ' => '&Otilde;',
				   '‌' => '&zwnj;',
				   'Ι' => '&Iota;',
				   '⊂' => '&sub;',
				   'Α' => '&Alpha;',
				   '³' => '&sup3;',
				   '∀' => '&forall;',
				   '¼' => '&frac14;',
				   '⌈' => '&lceil;',
				   '↑' => '&uarr;',
				   '­' => '&shy;',
				   '♥' => '&hearts;',
				   'ï' => '&iuml;',
				   '¡' => '&iexcl;',
				   'Μ' => '&Mu;',
				   'ç' => '&ccedil;',
				   '½' => '&frac12;',
				   'Î' => '&Icirc;',
				   '⊄' => '&nsub;',
				   '™' => '&trade;',
				   'λ' => '&lambda;',
				   'ë' => '&euml;',
				   'ζ' => '&zeta;',
				   'Ã' => '&Atilde;',
				   '∼' => '&sim;',
				   'ö' => '&ouml;',
				   'ϒ' => '&upsih;',
				   '♣' => '&clubs;',
				   '∨' => '&or;',
				   'ι' => '&iota;',
				   'Υ' => '&Upsilon;',
				   ' ' => '&thinsp;',
				   'ý' => '&yacute;',
				   'Ê' => '&Ecirc;',
				   '⊃' => '&sup;',
				   '⊕' => '&oplus;',
				   'ä' => '&auml;',
				   'Ζ' => '&Zeta;',
				   'μ' => '&mu;',
				   '’' => '&rsquo;',
				   'œ' => '&oelig;',
				   '¿' => '&iquest;',
				   'Û' => '&Ucirc;',
				   '‏' => '&rlm;',
				   'Ÿ' => '&Yuml;',
				   '—' => '&mdash;',
				   'Ì' => '&Igrave;',
				   '⇑' => '&uArr;',
				   '¥' => '&yen;',
				   'Œ' => '&OElig;',
				   '‰' => '&permil;',
				   '√' => '&radic;',
				   '∝' => '&prop;',
				   'Θ' => '&Theta;',
				   'Η' => '&Eta;',
				   'Ξ' => '&Xi;',
				   'Ε' => '&Epsilon;',
				   'ÿ' => '&yuml;',
				   'Ï' => '&Iuml;',
				   'ô' => '&ocirc;',
				   'η' => '&eta;',
				   '‎' => '&lrm;');
  static private $entkeys;
  static private $entvals;

  /**
   * Cette procédure initialise les vriables de classe
   * elle retourne ensuite la chaîne passée en argument dépourvue des entités HTML
   * presentes dans self::$entities.
   */
  static public function html_entities_to_utf8($strg) {
    if (!count(self::$entvals)) self::$entkeys = array_keys(self::$entities);
    if (!count(self::$entvals)) self::$entvals = array_values(self::$entities);
    return str_replace(self::$entvals, self::$entkeys, $strg);
  }

}
