// S5 v1.1 slides.js -- released into the Public Domain
//
// Please see http://www.meyerweb.com/eric/tools/s5/credits.html for information 
// about all the wonderful and talented contributors to this code!

var undef;
var slideCSS = '';
var snum = 0;
var smax = 1;
var incpos = 0;
var number = undef;
var s5mode = true;
var defaultView = 'outline';//'slideshow';
var controlVis = 'visible';
var blockArray = new Array("h1","h2","h3","h4","li","p","div","table","pre","dd","dt");
var blockArrayHead = new Array("h1","h2","h3");
//var defaultView = 'outline';
//var controlVis  = 'hidden';

var isIE = navigator.appName == 'Microsoft Internet Explorer' ? 1 : 0;
var isOp = navigator.userAgent.indexOf('Opera') > -1 ? 1 : 0;
var isWK = navigator.userAgent.indexOf('WebKit') > -1 ? 1 : 0;
var isGe = navigator.userAgent.indexOf('Gecko') > -1 && navigator.userAgent.indexOf('Safari') < 1 ? 1 : 0;

function hasClass(object, className) {
    if (!object.className) return false;
    return (object.className.search('(^|\\s)' + className + '(\\s|$)') != -1);
}

function hasValue(object, value) {
    if (!object) return false;
    return (object.search('(^|\\s)' + value + '(\\s|$)') != -1);
}

function removeClass(object,className) {
    if (!object) return;
    //var prev_class = object.className;
    //var expr = '(^|\\s)'+className+'(\\s|$)';
    //var reg = new RegExp(expr);
    //var new_class = prev_class.replace(reg, reg.$1+reg.$2);
    //var oclass = RegExp.$1+'?????'+RegExp.$2;
    object.className = object.className.replace(new RegExp('(^|\\s)'+className+'(\\s|$)'), RegExp.$1+RegExp.$2);
    //if (object.className.search('[0-9]') != -1) alert ('res class....: '+object.className+'\nbefore class.: '+prev_class+'\nto remove...: '+className+'\nregexp....:'+expr+'\n$1 $2....:'+oclass);
}

function addClass(object,className) {
    if (!object || hasClass(object, className)) return;
    if (object.className) {
	object.className += ' '+className;
    } else {
	object.className = className;
    }
}

function GetElementsWithClassName(elementName,className) {
    return GetElementsWithClassNameInParent(document, elementName, className);
}

function GetElementsWithClassNameInParent(parent, elementName, className) {
    var allElements = parent.getElementsByTagName(elementName);
    var elemColl = new Array();
    for (var i = 0; i< allElements.length; i++) {
	if (hasClass(allElements[i], className)) {
	    elemColl[elemColl.length] = allElements[i];
	}
    }
    return elemColl;
}

function isParentOrSelf(element, id) {
    if (element == null || element.nodeName=='BODY') return false;
    else if (element.id == id) return true;
    else return isParentOrSelf(element.parentNode, id);
}

function nodeValue(node) {
    var result = "";
    if (node.nodeType == 1) {
	var children = node.childNodes;
	for (var i = 0; i < children.length; ++i) {
	    result += nodeValue(children[i]);
	}		
    }
    else if (node.nodeType == 3) {
	result = node.nodeValue;
    }
    return(result);
}

numblock_array = new Array();
function slideRegister(slide,num) {
    numblock_array[num] = 0;
    if (num == 0 || num == smax-1) {
	for (var i = 0; i < blockArrayHead.length; i++) {
	    var elts = slide.getElementsByTagName(blockArrayHead[i]);
	    for (var j = 0; j < elts.length; j++) {
		numblock_array[num]++;
		addClass(elts[j], 'autoresize');
	    }
	}
    } else {
	var cnt = slide.getElementsByTagName('div')[0];
	if (cnt && hasClass(cnt,'slidecontent')) {
	    for (var i = 0; i < blockArray.length; i++) {
		var elts = cnt.getElementsByTagName(blockArray[i]);
		for (var j = 0; j < elts.length; j++) {
		    numblock_array[num]++;
		    addClass(elts[j], 'autoresize');
		}
	    }
	    var pNum = document.createElement('h5');
	    pNum.className = 'end_slide incremental';
	    pNum.appendChild(document.createTextNode(''));
	    cnt.appendChild(pNum);
	}
    }
}

function slideLabel() {
    var slideColl = GetElementsWithClassName('*','slide');
    var list = document.getElementById('jumplist');
    smax = slideColl.length;
    for (var n = 0; n < smax; n++) {
	var obj = slideColl[n];
	slideRegister(obj, n);
	var did = 'slide' + n.toString();
	obj.setAttribute('id',did);

	var otext = '';
	var menu = obj.firstChild;
	if (!menu) continue; // to cope with empty slides
	while (menu && menu.nodeType == 3) {
	    menu = menu.nextSibling;
	}
	if (!menu) continue; // to cope with slides with only text nodes
	
	var menunodes = menu.childNodes;
	for (var o = 0; o < menunodes.length; o++) {
	    otext += nodeValue(menunodes[o]);
	}
	if (list) list.options[list.length] = new Option(n + ' : '  + otext, n);
    }
}

function currentSlide() {
    var cs;
    if (document.getElementById) {
	cs = document.getElementById('currentSlide');
    } else {
	cs = document.currentSlide;
    }
    cs.innerHTML = '<span id="csHere">' + snum + '<\/span> ' + 
	'<span id="csSep">\/<\/span> ' + 
	'<span id="csTotal">' + (smax-2) + '<\/span>';
    if (snum == 0 || snum == smax-1) {
	cs.style.visibility = 'hidden';
    } else {
	cs.style.visibility = 'visible';
    }
}

function go(step) {
    //if (document.getElementById('slideProj').disabled || step == 0) return;
    if (step == 0) return;
    var jl = document.getElementById('jumplist');
    var cid = 'slide' + snum;
    var ce = document.getElementById(cid);
    if (incrementals[snum].length > 0) {
	for (var i = 0; i < incrementals[snum].length; i++) {
	    removeClass(incrementals[snum][i], 'current');
	    removeClass(incrementals[snum][i], 'incremental');
	}
    }
    if (step != 'j') {
	snum += step;
	lmax = smax - 1;
	if (snum > lmax) snum = lmax;
	if (snum < 0) snum = 0;
    } else {
	if (jl) snum = parseInt(jl.value);
	else snum = 2;
    }
    var nid = 'slide' + snum;
    var ne = document.getElementById(nid);
    if (!ne) {
	ne = document.getElementById('slide0');
	snum = 0;
    }
    if (step < 0) {incpos = incrementals[snum].length} else {incpos = 0;}
    if (incrementals[snum].length > 0 && incpos == 0) {
	for (var i = 0; i < incrementals[snum].length; i++) {
	    if (hasClass(incrementals[snum][i], 'current'))
		incpos = i + 1;
	    else
		addClass(incrementals[snum][i], 'incremental');
	}
    }
    if (incrementals[snum].length > 0 && incpos > 0)
	addClass(incrementals[snum][incpos - 1], 'current');
    removeClass(ce, 'current_slide');
    addClass(ne, 'current_slide');
    if (!document.getElementById('slideProj').disabled) ce.style.visibility = 'hidden';
    if (!document.getElementById('slideProj').disabled) ne.style.visibility = 'visible';
    if (jl) jl.selectedIndex = snum;
    currentSlide();
    number = 0;
    autoAdjust();
}

function autoAdjust() {
    reset_auto_adjust(0);
    setCss('slideProj','.slide .autoresize', 'lineHeight', 'normal');
    var curslide = document.getElementById('slide'+snum);
    var usable_space = getHeight(curslide);
    if (snum > 0 && snum < smax-1) {
	usable_space -= getHeight(curslide.getElementsByTagName('h2')[0]);
	usable_space -= getHeight(curslide.getElementsByTagName('div')[0]);
    } else {
 	for (var i = 0; i < blockArrayHead.length; i++) {
	    var c_list = curslide.getElementsByTagName(blockArrayHead[i]);
	    for (var j = 0; j < c_list.length; j++) {
		usable_space -= getHeight(c_list[j]);
	    }
	}
    }
    var marge_size = usable_space/(numblock_array[snum] + 1);
    if (marge_size > 0) {
	reset_auto_adjust(marge_size+'px');
	setCss('slideProj', '.slide .autoresize', 'lineHeight', 'normal');
    } else {
	setCss('slideProj', '.slide .autoresize', 'lineHeight', '1em');
    }
}

function getHeight(obj) {
    var resHeight = 0;
    if (obj) {
	if(obj.offsetHeight)          {resHeight = obj.offsetHeight;}
	else if(obj.style.pixelHeight){resHeight = obj.style.pixelHeight;}
    }
    return resHeight;
}

function goTo(target) {
    if (target >= smax || target == snum) return;
    go(target - snum);
}

function subgo(step) {
    //alert (getScrollPosition()[1]);
    if (step > 0) {
	removeClass(incrementals[snum][incpos - 1],'current');
	removeClass(incrementals[snum][incpos], 'incremental');
	addClass(incrementals[snum][incpos],'current');
	incpos++;
    } else {
	incpos--;
	removeClass(incrementals[snum][incpos],'current');
	addClass(incrementals[snum][incpos], 'incremental');
	addClass(incrementals[snum][incpos - 1],'current');
    }
}

function reset_auto_adjust(val) {
    setCss('slideProj','.slide .autoresize', 'marginTop', val);
    setCss('slideProj','.slide .autoresize', 'marginBottom', val);
}

function toggle() {
    var slideColl = GetElementsWithClassName('*','slide');
    var slides = document.getElementById('slideProj');
    var outline = document.getElementById('outlineStyle');
    if (!slides.disabled) {
	reset_auto_adjust('0.5em');
	slides.disabled = true;
	outline.disabled = false;
	s5mode = false;
	for (var n = 0; n < smax; n++) {
	    var slide = slideColl[n];
	    slide.style.visibility = 'visible';
	}
	location.href='#slide'+snum;
    } else {
	slides.disabled = false;
	outline.disabled = true;
	s5mode = true;
	autoAdjust();
	for (var n = 0; n < smax; n++) {
	    var slide = slideColl[n];
	    slide.style.visibility = 'hidden';
	}
	slideColl[snum].style.visibility = 'visible';
    }
}

function showHide(action) {
    var obj = GetElementsWithClassName('*','hideme')[0];
    switch (action) {
    case 's': obj.style.visibility = 'visible'; break;
    case 'h': obj.style.visibility = 'hidden'; break;
    case 'k':
	if (obj.style.visibility != 'visible') {
	    obj.style.visibility = 'visible';
	} else {
	    obj.style.visibility = 'hidden';
	}
	break;
    }
}

// 'keys' code adapted from MozPoint (http://mozpoint.mozdev.org/)

function keys(key) {
    if (!key) {
	key = event;
	key.which = key.keyCode;
    }
    evt = key || event;
    if (evt.shiftKey==1 || evt.ctrlKey==1 || evt.altKey==1) return;
    switch (key.which) {
    case 84: // t
	toggle();
	return;
    case 65: // a
	var links = incrementals[snum][incpos-1].getElementsByTagName('a');
	if (links.length > 0) location.href = links[0].href;
	return;
    case 80: // p
	var reg = new RegExp("/(index.html|\.?)$");
	if(reg.test(location.pathname)) {
	    var tstyle, tselect;
	    if (s5mode) {
		tstyle = 'slideProj';
		tselect = '.slide';
	    } else {
		tstyle = 'outlineStyle';
		tselect = '.current_slide';
	    }
	    var memstyle = getCss(tstyle, tselect, 'backgroundColor');
	    if (memstyle != 'rgb(0, 0, 0)') {
		setCss(tstyle, tselect, 'backgroundColor', '#000');
		setTimeout(function(){setCss(tstyle, tselect, 'backgroundColor', memstyle)}, 50);
	    }
	} else history.back();
	return;
    case 85: // u
	location.href='.';
	return;
    case 90: // page up
	go(-1);
	return;
    case 88: // page down
	go(1);
	return;
    default:
	if (key.which >= 48 && key.which < 58) goTo(key.which-48);
    }
    if (s5mode) {
	switch (key.which) {
	case 34: // page down
	    go(1);
	    break;
	case 33: // page up
	    go(-1);
	    break;
	case 10: // return
	case 13: // enter
	    if (window.event && isParentOrSelf(window.event.srcElement, 'controls')) return;
	    if (key.target && isParentOrSelf(key.target, 'controls')) return;
	    if(number != undef) {
		goTo(number);
		break;
	    }
	case 32: // spacebar
	case 39: // rightkey
	case 40: // downkey
	    if(number != undef) {
		go(number);
	    } else if (!incrementals[snum] || incpos >= incrementals[snum].length) {
		go(1);
	    } else {
		subgo(1);
	    }
	    break;
	case 37: // leftkey
	case 38: // upkey
	    if(number != undef) {
		go(-1 * number);
	    } else if (!incrementals[snum] || incpos <= 0) {
		go(-1);
	    } else {
		subgo(-1);
	    }
	    break;
	case 36: // home
	    goTo(0);
	    break;
	case 35: // end
	    goTo(smax-1);
	    break;
	case 67: // c
	    showHide('k');
	    break;
	}
	if (key.which < 48 || key.which > 57) {
	    number = undef;
	} else {
	    if (window.event && isParentOrSelf(window.event.srcElement, 'controls')) return;
	    if (key.target && isParentOrSelf(key.target, 'controls')) return;
	    number = (((number != undef) ? number : 0) * 10) + (key.which - 48);
	}
    } else {
	switch (key.which) {
	case 34: // page down
	    go(3);
	    break;
	case 33: // page up
	    go(-3);
	    break;
	case 36: // home
	    goTo(0);
	    break;
	case 35: // end
	    goTo(smax-1);
	    break;
	case 39: // rightkey
	    go(1);
	    break;
	case 37: // leftkey
	    go(-1);
	    break;
	}
    }
    return false;
}

function clicker(e) {
    number = undef;
    var target;
    if (window.event) {
	target = window.event.srcElement;
	e = window.event;
    } else target = e.target;
    if (target.getAttribute('href') != null || hasValue(target.rel, 'external') || isParentOrSelf(target, 'controls') || isParentOrSelf(target,'embed') || isParentOrSelf(target,'object')) return true;
    if (!e.which || e.which == 1) {
	if (!incrementals[snum] || incpos >= incrementals[snum].length) {
	    go(1);
	} else {
	    subgo(1);
	}
    }
}

function findSlide(hash) {
    var target = null;
    var slides = GetElementsWithClassName('*','slide');
    for (var i = 0; i < slides.length; i++) {
	var targetSlide = slides[i];
	if ( (targetSlide.name && targetSlide.name == hash)
	     || (targetSlide.id && targetSlide.id == hash) ) {
	    target = targetSlide;
	    break;
	}
    }
    while(target != null && target.nodeName != 'BODY') {
	if (hasClass(target, 'slide')) {
	    return parseInt(target.id.slice(5));
	}
	target = target.parentNode;
    }
    return null;
}

function slideJump() {
    if (window.location.hash == null) return;
    var sregex = /^#slide(\d+)$/;
    var matches = sregex.exec(window.location.hash);
    var dest = null;
    if (matches != null) {
	dest = parseInt(matches[1]);
    } else {
	dest = findSlide(window.location.hash.slice(1));
    }
    if (dest != null)
	go(dest - snum);
}

function fixLinks() {
    var thisUri = window.location.href;
    thisUri = thisUri.slice(0, thisUri.length - window.location.hash.length);
    var aelements = document.getElementsByTagName('A');
    for (var i = 0; i < aelements.length; i++) {
	var a = aelements[i].href;
	var slideID = a.match('\#slide[0-9]{1,2}');
	if ((slideID) && (slideID[0].slice(0,1) == '#')) {
	    var dest = findSlide(slideID[0].slice(1));
	    if (dest != null) {
		if (aelements[i].addEventListener) {
		    aelements[i].addEventListener("click", new Function("e",
									"if (document.getElementById('slideProj').disabled) return;" +
									"go("+dest+" - snum); " +
									"if (e.preventDefault) e.preventDefault();"), true);
		} else if (aelements[i].attachEvent) {
		    aelements[i].attachEvent("onclick", new Function("",
								     "if (document.getElementById('slideProj').disabled) return;" +
								     "go("+dest+" - snum); " +
								     "event.returnValue = false;"));
		}
	    }
	}
    }
}

function externalLinks() {
    if (!document.getElementsByTagName) return;
    var anchors = document.getElementsByTagName('a');
    for (var i=0; i<anchors.length; i++) {
	var anchor = anchors[i];
	if (anchor.getAttribute('href') && hasValue(anchor.rel, 'external')) {
	    anchor.target = '_blank';
	    addClass(anchor,'external');
	}
    }
}

function createControls() {
    var controlsDiv = document.getElementById("controls");
    if (!controlsDiv) return;
    var hider = ' onmouseover="showHide(\'s\');" onmouseout="showHide(\'h\');"';
    var hideDiv, hideList = '';
    if (controlVis == 'hidden') {
	hideDiv = hider;
    } else {
	hideList = hider;
    }
    controlsDiv.innerHTML = '<form action="#" id="controlForm"' + hideDiv + '>' +
	'<div id="navLinks">' +
	'<a id="toggle" href="javascript:toggle();">&#216;<\/a>' +
	'<a id="prev" href="javascript:go(-1);">&laquo;<\/a>' +
	'<a id="up" href=".">^<\/a>' +
	'<a id="next" href="javascript:go(1);">&raquo;<\/a>' +
	'<div id="navList"' + hideList + '><select id="jumplist" onchange="go(\'j\');"><\/select><\/div>' +
	'<\/div><\/form>';
    if (controlVis == 'hidden') {
	var hidden = document.getElementById('navLinks');
    } else {
	var hidden = document.getElementById('jumplist');
    }
    addClass(hidden,'hideme');
}

function getQueryStringParams() {
        var str = document.location.search;
        if (str.charAt(0)=='?') str=str.substring(1);
        var tab = str.split('&');
        var get = new Object();
        for (var i=0; i < tab.length; i++) {    
                var tab2 = tab[i].split('=');
                get[tab2[0]] = tab2[1];
        }
        return get;
}

function initDocument() {
    var lnkArray = new Array(new Array('image/x-icon', '', 'shortcut icon', 'images/icon.png', ''));
    /*new Array('text/css',     'projection', 'stylesheet', 'css/slides.css', 'slideProj'),
			     new Array('text/css',     'screen',     'stylesheet', 'css/screen.css', 'outlineStyle'),
			     new Array('text/css',     'print',      'stylesheet', 'css/print.css',  'slidePrint'),
			     new Array('text/css',     'all',        'stylesheet', 'css/all.css',    ''));*/
    var head = document.getElementsByTagName("head")[0];
    
    for (var i=0; i < lnkArray.length; i++) {
	    var link = document.createElement("link");
	    link.type = lnkArray[i][0];
	    if (lnkArray[i][1]) link.media = lnkArray[i][1];
	    if (lnkArray[i][2]) link.rel   = lnkArray[i][2];
	    link.href = lnkArray[i][3];
	    if (lnkArray[i][4]) link.id = lnkArray[i][4];
	    head.appendChild(link);
    }
    var print_dest = getQueryStringParams()['print'];
    if (print_dest) {
	var link = document.createElement("link");
	link.rel = 'stylesheet';
	link.type = 'text/css';
	link.media = 'print';
	link.href = 'css/print_'+print_dest+'.css';
	head.appendChild(link);
    }    
    /*var linkIcon = document.createElement("link");
    linkIcon.type = "image/x-icon";
    linkIcon.rel = "shortcut icon";
    linkIcon.href = 'images/icon.png';
    head.appendChild(linkIcon);
    
    <link rel="stylesheet" type="text/css" media="projection" href="css/slides.css" id="slideProj" />
    <link rel="stylesheet" type="text/css" media="screen" href="css/screen.css" id="outlineStyle" />
    <link rel="stylesheet" type="text/css" media="print" href="css/print.css" id="slidePrint" />
    <link rel="stylesheet" type="text/css" media="all" href="css/all.css" />*/

    var lastSlide = document.createElement('div');
    lastSlide.className = 'slide lastSlide';
    var title = document.getElementById('slide0').getElementsByTagName('h1')[0].innerHTML;
    lastSlide.innerHTML = '<h3>Fin de présentation</h3><h2>'+title+'</h2>'+
	'<div class="validator">'+
	'pages validées par '+
	'<a href="http://validator.w3.org/check?uri=referer"><img src="images/valid_xhtml.svg" alt="Valid XHTML 1.1" title="xHTML 1.1 validé !" /></a> '+
	'<a href="http://jigsaw.w3.org/css-validator/check/referer"><img src="images/valid_css.svg" alt="CSS validé !" title="CSS validé !"/></a>'+
	'</div>';   
    document.getElementsByTagName('body')[0].appendChild(lastSlide);
}

function fontScale() {  // causes layout problems in FireFox that get fixed if browser's Reload is used; same may be true of other Gecko-based browsers
    return;
    var rsize;
    var slides = document.getElementById('slideProj');
    var ph = getHeight(document.getElementById('slide0'));
    //alert(ph+'---'+fh);
    rsize = (ph/20)+'px';
    setCss('slideProj', 'body', 'font-size', rsize);
}

function browserFix() {
    var outline = document.getElementById('outlineStyle');
    var slides = document.getElementById('slideProj');
    slideCSS = slides.href;
    slides.setAttribute('media','screen');
    outline.disabled = true;
    if (isGe) {
	slides.setAttribute('href','null');   // Gecko fix
	slides.setAttribute('href',slideCSS); // Gecko fix
    }
    if (isOp) {
	slides.setAttribute('media','all'); // Opera fix
	outline.setAttribute('media','all'); // Opera fix
    }
    if (isIE && document.styleSheets && document.styleSheets[0]) {
	document.styleSheets[0].addRule('img', 'behavior: url(ui/default/iepngfix.htc)');
	document.styleSheets[0].addRule('div', 'behavior: url(ui/default/iepngfix.htc)');
	document.styleSheets[0].addRule('.slide', 'behavior: url(ui/default/iepngfix.htc)');
    }
}

function getIncrementals(obj) {
    var incrementals = new Array();
    if (!obj) 
	return incrementals;
    var children = obj.childNodes;
    for (var i = 0; i < children.length; i++) {
	var inode = null;
	var child = children[i];
	if (!hasClass(child, 'no_incremental') && (hasClass(child, 'incremental') || hasClass(child, 'show_first')
						   || child.nodeName == 'OL' || child.nodeName == 'UL' || child.nodeName == 'DL'
						   || child.nodeName == 'H2' || child.nodeName == 'H3' || child.nodeName == 'H4'
						   || child.nodeName == 'H5' || child.nodeName == 'H6' || child.nodeName == 'P'
						   || child.nodeName == 'TABLE' || child.nodeName == 'TBODY' || child.nodeName == 'DIV')) {
	    removeClass(child, 'incremental');
	    if (child.nodeName == 'OL' || child.nodeName == 'UL' || child.nodeName == 'DL' || child.nodeName == 'TABLE' || child.nodeName == 'TBODY') {
		var pnode = child;
		if (child.nodeName == 'TABLE') {
		    pnode = child.getElementsByTagName('TBODY')[0];
		}
		for (var j = 0; j < pnode.childNodes.length; j++) {
		    if (pnode.childNodes[j].nodeType == 1) {
			addClass(pnode.childNodes[j], 'incremental');
		    }
		}
	    } else {
		inode = child;
	    }
	    if (hasClass(child, 'show_first')) {
		removeClass(child, 'show_first');
		incrementals = getIncrementals(child).concat(incrementals);
		if (inode) incrementals.unshift(child);
	    } else {
		if (inode) incrementals.push(child);
		incrementals = incrementals.concat(getIncrementals(child));
	    }
	}
    }
    return incrementals;
}

function createIncrementals() {
    var incrementals = new Array();
    for (var i = 0; i < smax; i++) {
	var elmt = GetElementsWithClassNameInParent(document.getElementById('slide'+i), '*', 'slidecontent');
	incrementals[i] = getIncrementals(elmt[0]);
    }
    return incrementals;
}

function defaultCheck() {
    var allMetas = document.getElementsByTagName('meta');
    for (var i = 0; i< allMetas.length; i++) {
	if (allMetas[i].name == 'defaultView') {
	    defaultView = allMetas[i].content;
	}
	if (allMetas[i].name == 'controlVis') {
	    controlVis = allMetas[i].content;
	}
    }
}

// Key trap fix, new function body for trap()
function trap(e) {
    if (!e) {
	e = event;
	e.which = e.keyCode;
    }
    try {
	modifierKey = e.ctrlKey || e.altKey || e.metaKey;
    }
    catch(e) {
	modifierKey = false;
    }
    return modifierKey || e.which == 0;
}

// cette fonction est inutile si CSS3 est suporté !
function set_vertical_text() {
    var v = 'Khtml Ms O Moz Webkit'.split(' ');
    for(var t = 0; t <= v.length; t++) {
	i = 'Transform';
        if (t != v.length) i = v[t]+i;
	if (i in document.getElementById('title').style) return;
    }
    document.getElementById('header').style.width = '2em';
    document.getElementById('header').style.height = '100%';
    document.getElementById('title').style.textAlign = 'center';
    document.getElementById('title').style.fontVariant = 'small-caps';
    text = document.getElementById('title').innerHTML;
    text = text.replace(/(<([^>]+)>)/ig,""); 
    text = text.replace(/(.)/g,'$1<br/>')
    document.getElementById('title').innerHTML = text;
}

function updateCounterTitle(chapTag, incrClass, resetClass, target) {
    var incrs=document.getElementsByTagName(chapTag);
    var countTitles=new Array();
    for(var i=0; i != incrs.length; i++) {
	var classList = incrs[i].className.split(' ');
	to_show  = false;
	to_reset = false;
	for(var j=0; j!=classList.length; j++) {
	    if (classList[j] == incrClass) to_show = true;
	    if (classList[j] == resetClass) {
		to_show  = true;
		to_reset = true;
	    }
	    if (i == incrs.length-1) to_reset = true;
	}
	
	if (to_reset) {
	    t = countTitles.length;
	    while (countTitles.length > 0) {
		countTitles.pop().appendChild(document.createTextNode('/'+t));
	    }
	}

	if (to_show) {
	    var label = incrs[i].getElementsByTagName(target);
	    if (label.length > 0) {
		var iNum = document.createElement('cite');
		label[0].appendChild(iNum);
		countTitles.push(iNum);
		iNum.appendChild(document.createTextNode(' '+countTitles.length));
	    }
	}
    }
}

function startup() {
    initDocument();
    defaultCheck();
    createControls();
    slideLabel();
    fixLinks();
    externalLinks();
    //set_vertical_text(); # desomais inutinle car CSS3 opérationnels sur tous les navigateurs
    updateCounterTitle('div', 'incr', 'reset', 'h2');

    browserFix();
    incrementals = createIncrementals();
    slideJump();
    if (defaultView == 'outline') {
	toggle();
    }
    document.onkeyup = keys;
    //document.onkeypress = trap;
    //document.onclick = clicker;

    fontScale();
    autoAdjust();
}

function getCss_from_id(id) {
    var href = document.getElementById(id).href;
    for (var i = 0; i < document.styleSheets.length; i++) {
	if (document.styleSheets[i].href == href) return document.styleSheets[i];
    }
    return false;
}

function getCss(id, selector, attribute) {
    var stsh = getCss_from_id(id);
    if (stsh) {
	if (stsh.cssRules) {
	    for (var i = 0; i < stsh.cssRules.length; i++) {
		if (stsh.cssRules[i].selectorText == selector) {
		    return stsh.cssRules[i].style[attribute];
		}
	    }
	}
    } else {
	return false;
    }
}

function setCss(id, selector, attribute, value) {
    var stsh = getCss_from_id(id);
    if (stsh) {
	if (stsh.cssRules) {
	    for (var i = 0; i < stsh.cssRules.length; i++) {
		if (stsh.cssRules[i].selectorText == selector) {
		    stsh.cssRules[i].style[attribute] = value;
		    return true;
		}
	    }
	} else {
	    var style = document.getElementById('extra_css');
	    if (!style) {
		style = document.createElement('style');
		var head = document.getElementsByTagName('head')[0];
		style.type = 'text/css';
		style.id = 'extra_css';
		head.appendChild(style);
	    }
	    if (style.cssRules) {
		for (var i = 0; i < style.cssRules.length; i++) {
		    if (style.cssRules[i].selectorText == selector) {
			style.cssRules[i].style[attribute] = value;
			return true;
		    }
		}
	    }

	    //var rules = document.createTextNode(selector+' {'+attribute+':'+value+'}');
	    //if(style.styleSheet) style.styleSheet.cssText = rules.nodeValue;
	    //else if (style.hasChild) style.replaceChild(rules, style.firstChild);
	    //else style.innerHTML = selector+' {'+attribute+':'+value+'}';
	}
    }
    return false;
}

window.onload = startup;
//window.onresize = function(){setTimeout('fontScale()', 50);}
window.onresize = function(){setTimeout('autoAdjust()');}